
//============================================================== I²C Interrupt Service Routines ================================================
void DataReceived(int bytes)      
{
  lspeed=Wire.read()*256+Wire.read();                       // read left  motor speed integer
  rspeed=Wire.read()*256+Wire.read();                       // read right motor speed integer 
  byte reset=Wire.read();                                   // reset distance counters?
  if(reset>0)                                               // if reset>0 then reset counters
  {
    lcount=0;                                               // reset left  distance counter
    rcount=0;                                               // reset right distance counter
  }

  while(Wire.available()>0)                                 // if the buffer is not empty then flush the buffer
  {
    reset=Wire.read();                                      // remove byte from buffer
  } 
}


void DataSend()
{
  byte datapack[6];
  datapack[0]=highByte(lcount);                             // send high byte of left  distance counter
  datapack[1]= lowByte(lcount);                             // send low  byte of left  distance counter
  datapack[2]=highByte(rcount);                             // send high byte of right distance counter
  datapack[3]= lowByte(rcount);                             // send low  byte of right distance counter
    
  int bvolts=analogRead(powerpin);                          // read battery voltage
  datapack[4]=highByte(bvolts);                             // send high byte of battery voltage
  datapack[5]= lowByte(bvolts);                             // send low  byte of battery voltage
  Wire.write(datapack,6);
}

